#!/bin/bash

# read settings
if [ -z "$FIMIDIR" ] ; then
    if . ./settings ; then
        x=1 # do nothing
    else
        echo Error: either create ./settings or set FIMIDIR variable to the directory of it >&2
        exit 1
    fi
else 
    if . $FIMIDIR/settings ; then
        x=1
    else
        echo Error: $FIMIDIR/settings not found. Set FIMIDIR variable correctly. >&2
        exit 1
    fi
fi

if [ ! -f "$1" ] ; then
    echo usage: $0 resultsfile [counter [runid]]
    echo counter defaults to tsc, runid to 2
    echo normally you supply fimilog to the resultsfile
else
    fin=$1
fi

runid=$3 

if [ -z "$2" ] ; then
    counter=tsc
    runid=""
else
    counter=$2
fi

export SCALE=2800000000
export YTEXT='Time (seconds, log-scale)'

JFILE=$TEMPDIR/jfile.$$
INFS=$TEMPDIR/sfile.$$

grep "[^:]*:$counter:$runid" $DETLOG | sort > $JFILE

cat $fin | sort > $INFS

JOINFILE=$TEMPDIR/joinfile.$$

join -t : -1 1 -2 1 $INFS $JFILE -o "1.1,2.1,1.2,1.3,1.4,1.5,1.1,2.4" > $JOINFILE

cat $JOINFILE | sort -t: -k4,4 -k3,3 -k6,6rn | $SCRIPTDIR/freqplot.awk 

gnuplot plotrunner.gnuplot

exit
grep "[^:]*:$counter:$runid" $DETLOG | sort > $JFILE

cat $fin | sort > $INFS

JOINFILE=$TEMPDIR/joinfilek.$$

join -t : -1 1 -2 1 $INFS $JFILE -o "1.1,2.1,1.2,1.3,1.4,1.5,1.1,2.4" > $JOINFILE

cat $JOINFILE | sort -t: -k4,4 -k6,6n -k8,8n | $SCRIPTDIR/rank.awk 




grep "[^:]*:status:[^:]*:[^0]" $DETLOG | sort > $JFILE

cat $fin | sort > $INFS

JOINFILE=$TEMPDIR/joinfilei.$$

join -t : -1 1 -2 1 $INFS $JFILE -o "1.1,2.1,1.2,1.3,1.4,1.5,1.1,2.4" > $JOINFILE

cat $JOINFILE | sort -t: -k4,4 -k3,3 -k5,5rn | $SCRIPTDIR/missinggen.awk 
