#!/usr/bin/gawk -f
BEGIN {
  FS=":";
  outfile="plotrunner.gnuplot";
  if ("PLOTEPS" in ENVIRON) {
    extx="eps";
    print "\
        set terminal postscript eps mono\n\
	set size 0.7,0.7\n\
" > outfile;  
  } else {
  	extx="png";
	print "\
set terminal png small picsize 720 600\n set pointsize 2.0" > outfile;
			
  } 
  if ("XTEXT" in ENVIRON) {
    xtext=ENVIRON["XTEXT"];
  } else {
    xtext="min_supp";
  }
  if (1) {
  print "\
	set encoding iso_8859_1\n\
	set nologscale\n\
        set logscale y\n\
	set data style linespoints\n\
	set xlabel \"" xtext "\"\n\
	set key right top\n\
	set xrange[] reverse\n\
	set ylabel \"" ENVIRON["YTEXT"] "\"\n\
	set yrange[*:250]\n\
	" > outfile;
  } else {
  print "\
	set encoding iso_8859_1\n\
	set nologscale\n\
        set logscale xy\n\
	set data style linespoints\n\
	set xlabel \"" xtext "\"\n\
	set key right bottom\n\
	set ylabel \"" ENVIRON["YTEXT"] "\"\n\
	set yrange[*:*]\n\
	" > outfile;
  }

#run time (seconds, log-scale)
  lastdiag="";
  lastprog="jkxnha";
  idx=1;
  rescale=ENVIRON["SCALE"];
  if (!rescale) {
    rescale=1;
  }
  
}

function dumpprog() {
    filename="/tmp/gdat." db "." prog "." PROCINFO["pid"] ".gdat";
    if (plotfiles!="") {
      plotfiles=plotfiles ", ";
    }
    plotfiles=plotfiles "\"" filename "\"  title \"" prog "\" "; # idx++;
    lastprog=prog;
}

function dumpdiag() {
  if(lastdiag=="")
    return;
#  printf("set xrange[%s:%s] reverse\n",xmin,xmax)>>outfile;
#  printf("set xrange[%s:%s] reverse\n",xmin,xmax)>>outfile;
 # printf("set yrange[%f:%f]\n",ymin,ymax)>>outfile;
  print "plot " plotfiles >>outfile;
  #cleanup
  plotfiles="";
  ymin=0;
  ymax=0;
  xmin=1000000;
  xmax=0;
  lastprog="askdefkjafniura";
  idx=1;
}



{
  prog=$3;
  if (match($4,"/([^/]*)$",dblast)) {
    db=substr($4,dblast[1,"start"],dblast[1,"length"]);
  } else {
    db=$4;
  }
  psup=$6;
  sumtime=$8/rescale;
  if(db!=lastdiag) {
    dumpdiag();
    lastdiag=db;
    print "set title \"" db "\"" >> outfile;
    print "set output \"outputs/" db "." extx "\"" >> outfile;
  }
  if(prog!=lastprog) {
    dumpprog();
  }
  printf("%s\t%s\n",psup,sumtime)>>filename;
  if (psup<xmin)
    xmin=psup;
  if (psup>xmax)
    xmax=psup;
  if (sumtime>ymax)
    ymax=sumtime;

}

END {
  dumpdiag();
}
