#!/usr/bin/gawk -f
BEGIN {
  FS=":";
  lastdiag="";
  lastprog="jkxnha";
  idx=1;
}

function dumpprog() {
  if (!firstprog) {
    print "</ul>" >>outfile;
  }
  firstprog=0;
  print "<LI>" prog "</LI><UL>" >> outfile;
  lastprog=prog;
}

function dumpdiag() {
  if(lastdiag=="")
    return;
#  printf("set xrange[%s:%s] reverse\n",xmin,xmax)>>outfile;
#  printf("set xrange[%s:%s] reverse\n",xmin,xmax)>>outfile;
 # printf("set yrange[%f:%f]\n",ymin,ymax)>>outfile;
  if (firstprog) {
    print "<LI>No missing points.</LI>">>outfile;
  } else {
    print "</ul>" >>outfile;
  }
  print "</ul></body></html>">>outfile;
  plotfiles="";
  lastprog="askdefkjafniura";
  idx=1;
}

function interpretresult(result) {
  if (result==6) {
    return "SIGABRT, abort, possibly memory limit exceeded";
  }
  if (result==11) {
    return "SIGSEGV, segmentation fault, program failure or memory limit exceeded (with unchecked allocation)";
  }
  if (result==24) {
    return "SIGXCPU, time limit exceeded";
  }
  if (result==0) {
    return "Normal program termination";
  }
  return "Unknown result code.";
}


{
  prog=$3;
  match($4,"/([^/]*)$",dblast);
  db=substr($4,dblast[1,"start"],dblast[1,"length"]);
  psup=$6;
  result=$8;
  if(db!=lastdiag) {
    dumpdiag();
    lastdiag=db;
    outfile="outputs/" db ".missing.html";
    print "<html><head><title>Missing data points for DB " db "</title></head><body><ul>" > outfile;
    firstprog=1;
  }
  if(prog!=lastprog) {
    dumpprog();
  }
  print "<LI>support " psup " result " result ", " interpretresult(result) "</li>" >> outfile;
#  printf("%s\t%s\n",psup,sumtime)>>filename;
}

END {
  dumpdiag();
}
