#!/usr/bin/gawk -f
BEGIN {
  FS=":";
  lastdiag="";
  lastsupp=-1;
  outfile="outputs/rank.html";
  print "<html><head><title>FIMI benchmark rankings</title></head><body><ul>" > outfile;
  idx=1;
}

function dumpprog() {
  if (!firstprog) {
    print "</ul>" >>outfile;
  }
  firstprog=0;
  print "<LI>" prog "</LI><UL>" >> outfile;
  lastprog=prog;
}

function dumpdiag() {
  if(lastdiag=="")
    return;
#  printf("set xrange[%s:%s] reverse\n",xmin,xmax)>>outfile;
#  printf("set xrange[%s:%s] reverse\n",xmin,xmax)>>outfile;
 # printf("set yrange[%f:%f]\n",ymin,ymax)>>outfile;
  delete sortarr;
  for(prgname in pointarr) {
    sortarr[sprintf("%08.2f",pointarr[prgname]/countarr[prgname]),prgname]=1;
  }
  asorti(sortarr);
  for(i=1;i in sortarr;i++) {
    split(sortarr[i],sparr,SUBSEP);
    prgname=sparr[2];
    val=sparr[1];
#    print sortarr[i] " name " prgname " val " val;
    print "<tr><td>" prgname "</td>" >> outfile;
    printf "<td>%.2f</td><td>%d</td><td>%d</td><td>%s</td></tr>\n", val,countarr[prgname],wincount[prgname],winarr[prgname] >> outfile;
  }
  
  print "</table></li>">>outfile;
  plotfiles="";
  lastprog="askdefkjafniura";
  idx=1;
  delete pointarr;
  delete countarr;
  delete winarr;
  delete wincount;
  delete supparr;
}

function interpretresult(result) {
  if (result==6) {
    return "SIGABRT, abort, possibly memory limit exceeded";
  }
  if (result==11) {
    return "SIGSEGV, segmentation fault, program failure or memory limit exceeded (with unchecked allocation)";
  }
  if (result==24) {
    return "SIGXCPU, time limit exceeded";
  }
  if (result==0) {
    return "Normal program termination";
  }
  return "Unknown result code.";
}


{
  prog=$3;
  match($4,"/([^/]*)$",dblast);
  db=substr($4,dblast[1,"start"],dblast[1,"length"]);
  psup=$6;
  result=$8;
  if(db!=lastdiag) {
    dumpdiag();
    lastdiag=db;
    print "<HR/><LI>Database " db >> outfile;
    print "<table><tr><td>Program</td><td>Avg score</td><td>NumResults</td><td>#Wins</td><td>Wins</td></tr>" >> outfile;
#    outfile="outputs/" db ".missing.html";
    firstprog=1;
  }
  if(! (psup in supparr)) {
    supparr[psup]=result;
    if (prog in winarr) {
      winarr[prog]=winarr[prog] ", "psup;
    } else {
      winarr[prog]=psup;
    }
    wincount[prog]++;
    totwincount[prog]++;
  } 
  pointarr[prog]+=result/supparr[psup];
  countarr[prog]++;
}

END {
  dumpdiag();
  print "</ul><hr/><hr/><table><tr><td>Program</td><td># Wins</td></tr>" >> outfile;
  delete sortarr;
  for(prgname in totwincount) {
    sortarr[sprintf("%08d",totwincount[prgname]),prgname]=1;
  }
  asorti(sortarr);
  for(i=1;i in sortarr;i++) {
    split(sortarr[i],sparr,SUBSEP);
    prgname=sparr[2];
    val=sparr[1];
#    print sortarr[i] " name " prgname " val " val;
    print "<tr><td>" prgname "</td>" >> outfile;
    printf "<td>%d</td></tr>", val >> outfile;
  }
  
  print "</table>">>outfile;
  
  print "</body></html>" >> outfile;
}
