/***************************************************************************
                          OneByOneSupportCounter.hpp  -  description
                             -------------------
    begin                : cs dec 26 2004
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef OneByOneSupportCounter_HPP
#define OneByOneSupportCounter_HPP

/**
  *@author Ferenc Bodon
  */


#include "common.hpp"
#include <vector>
//#include <cstdio>
//#include <iterator>	//for test



/** OnyByOneSupportCounter treats transactions individually, i.e. 
    it reads the transactions one by one and calls the support count 
    method for each of them.
 */

template <class DATA_STRUCTURE, class SC, class TR>
class OneByOneSupportCounter
{
   private:

      DATA_STRUCTURE& data_structure;
      TR& transaction_reader;
      SC support_counter;

   public:
      OneByOneSupportCounter( DATA_STRUCTURE& data_structure,
			      TR& transaction_reader) :
	 data_structure(data_structure), 
	 transaction_reader(transaction_reader){}
      void countSupport(const unsigned int candidate_size);
};

template <class DATA_STRUCTURE, class SC, class TR> inline void 
OneByOneSupportCounter<DATA_STRUCTURE, SC, TR>::
countSupport(const unsigned int candidate_size )
{
   assert( candidate_size > 2 );
   transaction_reader.rewind();
   std::vector<item_t> transaction;
   counter_t multiplicity;
   while( (multiplicity = transaction_reader.nextTransactionBIS(
	      transaction)) !=0 )
      if( candidate_size <= transaction.size() )
	 support_counter.updateCounters(
	    data_structure, transaction, 
	    candidate_size, multiplicity);

}
#endif
