/***************************************************************************
                          FrequentPairInserterNoprune.hpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef FrequentPairInserterNoprune_prefix_HPP
#define FrequentPairInserterNoprune_prefix_HPP

/**
  *@author Ferenc Bodon
  */


#include "common.hpp"
#include "datastructures/PrefixArrayList.hpp"
//#include <cstdio>
//#include <iterator>	//for test


namespace Bodon
{
namespace prefix_array
{
template <class DATASTRUCTURE, class D, class DUMMY>
class FrequentPairInserterNoprune
{
   protected:
      DATASTRUCTURE& candidates; 
      D& decoder;

   public:
      FrequentPairInserterNoprune( DATASTRUCTURE& candidates, 
				   D& decoder, DUMMY& dummy ) : 
	 candidates(candidates), decoder(decoder){}


      /// Insert the frequent itempairs and their counters into the data structure;
      void insertFrequentPairs(
	 const std::vector< std::pair< counter_t, 
	 std::pair<item_t, item_t> > >& freq_pairs_with_counters )
      {
	 itemvector itemset;
	 for( std::vector< std::pair< counter_t, std::pair<item_t, item_t> > >::const_iterator 
		 it = freq_pairs_with_counters.begin(); it != freq_pairs_with_counters.end(); ++it)
	 {
	    itemset.push_back((*it).second.first);
	    itemset.push_back((*it).second.second);
	    decoder.writeItemsetAndCounter(itemset.begin(), itemset.end(), (*it).first);
	    itemset.clear();
	    candidates[(*it).second.first][(*it).second.second-(*it).second.first -1].
	       push_back(itemvecCounterPair(itemset, 0 ) );
	 }
      }
};

}
}

#endif
