/***************************************************************************
                          InfrequentRemover.cpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef InfrequentRemover_prefix_HPP
#define InfrequentRemover_prefix_HPP

/**
  *@author Ferenc Bodon
  */


#include "apriori/bodon-vector/vector_typedef.hpp"
#include "common/log.h"
//#include <cstdio>
//#include <iterator>	//for test




namespace Bodon
{
namespace prefix_array
{
   template <class DATASTRUCTURE,class D, class DUMMY>
   class InfrequentRemover 
   {
      protected:
	 DATASTRUCTURE& candidates; 
	 D& decoder;
	 DUMMY& dummy;
      public:
	 InfrequentRemover<DATASTRUCTURE, D, DUMMY> 
	 (DATASTRUCTURE& candidates, D& decoder, DUMMY& dummy) :
	    candidates(candidates), decoder(decoder), 
	    dummy(dummy){}


	 void deleteInfrequent( const counter_t min_supp, 
				const unsigned int candidate_size );
	 void afterWorkDel(){}
      protected:


   };
/**
   \param min_supp The threshold of absolute support.
   \param candidate_size The size of the candidate itemset.
*/
   template <class DATASTRUCTURE, class D, class DUMMY> inline
   void InfrequentRemover<DATASTRUCTURE, D, DUMMY>::
   deleteInfrequent( const counter_t min_supp, 
		     const unsigned int candidate_size )
   {
      for( typename DATASTRUCTURE::size_type index1 = 0;
	   index1 != candidates.size(); ++index1)
	 for( diag_array_row_t::size_type index2 = 0; 
	      index2 != candidates[index1].size(); ++index2)
	 {
	    cand_vector_t::iterator it = candidates[index1][index2].begin(); 
	    while(it != candidates[index1][index2].end())
	       if((*it).second < min_supp)
		  it = candidates[index1][index2].erase(it);
	       else
	       {
		  (*it).first.push_back(index1);
		  (*it).first.push_back(index2 + index1 + 1);
		  decoder.writeItemsetAndCounter(
		     (*it).first.begin(), (*it).first.end(), (*it).second);
		  (*it).first.pop_back();
		  (*it).first.pop_back();
		  ++it;
	       }
	 }
   }

}
}
#endif
