/***************************************************************************
                          SupportCounter.hpp  -  description
                             -------------------
    begin                : cs dec 26 2004
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef SupportCounter_prefix_HPP
#define SupportCounter_prefix_HPP

/**
  *@author Ferenc Bodon
  */


#include "apriori/bodon-vector/SupportCounter.hpp"
#include "apriori/bodon-vector/vector_typedef.hpp"
//#include <cstdio>
//#include <iterator>	//for test




namespace Bodon
{
namespace prefix_array
{
   template<class DATA_STRUCTURE>
   class SupportCounter
   {
      protected:
	 Bodon::vector_based::SupportCounter<cand_vector_t> supp_count;
      public:
	 SupportCounter<DATA_STRUCTURE>(){}

      public:
	 /// Increases the counter of those candidates that are contained 
	 /// by the given basket.
	 void updateCounters( 
	    DATA_STRUCTURE& candidates, const std::vector<item_t>& transaction, 
	    const unsigned int candidate_size, const counter_t counter_incr );
	 void updateCounters( 
	    DATA_STRUCTURE& candidates, std::vector<item_t>::iterator transaction_beg, 
	    std::vector<item_t>::iterator transaction_end,
	    const unsigned int candidate_size, const counter_t counter_incr );
   };

   template<class DATA_STRUCTURE>
   void inline SupportCounter<DATA_STRUCTURE>::updateCounters( 
      DATA_STRUCTURE& candidates, const std::vector<item_t>& transaction, 
      const unsigned int candidate_size, const counter_t counter_incr )
   {
//      copy(transaction.begin(), transaction.end(), ostream_iterator<item_t>(std::cout, " "));
//      std::cout<<std::endl;
      for(std::vector<item_t>::const_iterator it1 = transaction.begin();
	 it1 != transaction.end()- candidate_size +1; ++it1)
	 for(std::vector<item_t>::const_iterator it2 = it1 + 1;
	     it2 != transaction.end() - candidate_size + 2; ++it2)
	 {
	    supp_count.updateCounters(
	       candidates[*it1][*it2 - *it1 - 1], 
	       it2+1, transaction.end(), candidate_size, counter_incr);
	 }
   }
}
}
#endif
