/***************************************************************************
                          CandidateGeneratorNoprune.cpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef CandidateGeneratorNoprune_HPP
#define CandidateGeneratorNoprune_HPP

/**
  *@author Ferenc Bodon
  */


#include "apriori/bodon-vector/vector_typedef.hpp"
#include "common/log.h"
//#include <cstdio>
//#include <iterator>	//for test




namespace Bodon
{
namespace vector_based
{
   template <class D, class DUMMY>
   class CandidateGeneratorNoprune 
   {
      protected:
	 cand_vector_t& candidates; 
      public:
	 CandidateGeneratorNoprune<D, DUMMY> 
	 ( cand_vector_t& candidates, D& decoder, DUMMY& dummy) :
	    candidates(candidates){}


	 /** Generates candidates 
	  
	 Generates candidates and writes frequent itemset 
	 that are obtained in the previous iteration to disk.
	 */
	 void generateCandidate(unsigned int candidate_size);
      
	 void afterWorkCandGen(){}

	 bool isThereAnyCandidate()
	 {
	    return !candidates.empty();
	 }
   };


   template <class D, class DUMMY> inline
   void CandidateGeneratorNoprune<D, DUMMY>::
   generateCandidate(const unsigned int candidate_size)
   {
      if(!candidates.empty())
      {
	 cand_vector_t::size_type orig_size(candidates.size());
	 itemvector new_candidate;
	 cand_vector_t::size_type index=0, index2;
	 for(;index < orig_size -1; ++index)
	 {
	    new_candidate.clear();
	    new_candidate.insert(new_candidate.end(),
				 candidates[index].first.begin(),
				 candidates[index].first.end());
	    index2 = index +1;
	    while(index2 < orig_size && 
		  candidates[index].first.haveSamePrefix(candidates[index2].first))
	    {
		  new_candidate.push_back(candidates[index2].first.back());
		  candidates.push_back( 
		     itemvecCounterPair(new_candidate, 0));
		  new_candidate.pop_back();
		  ++index2;
	    }
	 }
	 candidates.erase(candidates.begin(), candidates.begin()+orig_size);
      }
   }
}
}
#endif
