/***************************************************************************
                          FrequentItemInserter.hpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef FrequentItemInserter_HPP
#define FrequentItemInserter_HPP

/**
  *@author Ferenc Bodon
  */

#include "apriori/bodon-vector/vector_typedef.hpp"
#include "common.hpp"
#include <vector>
//#include <cstdio>
//#include <iterator>	//for test


namespace Bodon
{
namespace vector_based
{
template <class DATASTRUCTURE, class D>
class FrequentItemInserter
{
   protected:
      D& decoder;
   public:
      FrequentItemInserter<DATASTRUCTURE, D>( DATASTRUCTURE& candidates, 
			       D& decoder ) :
	 decoder(decoder) {}

      /// This set the support of the emptyset.
      void setEmptysetSupport(const counter_t emptyset_support)
      {
	 std::vector<item_t> itemset;
	 decoder.writeItemsetAndCounter(
	    itemset.begin(), itemset.end(), emptyset_support);
      }

      /// Insert the frequent items and their counters into the data structure;
      void insertFrequentItems(const std::vector<counter_t>& freq_counters )
      {
	 std::vector<item_t> itemset;
	 for(std::vector<counter_t>::size_type index=0; 
	     index< freq_counters.size(); ++index )
	 {
	    itemset.push_back(index);
	    decoder.writeItemsetAndCounter(
	       itemset.begin(), itemset.end(), freq_counters[index]);
	    itemset.pop_back();
	 }
      }
};
}
}

#endif
