/***************************************************************************
                          FrequentPairInserterNoprune.hpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef FrequentPairInserterNoprune_HPP
#define FrequentPairInserterNoprune_HPP

/**
  *@author Ferenc Bodon
  */


#include "common.hpp"
#include "apriori/bodon-vector/vector_typedef.hpp"
#include <vector>
//#include <cstdio>
//#include <iterator>	//for test


namespace Bodon
{
namespace vector_based
{
template <class D, class DUMMY>
class FrequentPairInserterNoprune
{
   protected:
      cand_vector_t& candidates; 
      D& decoder;

   public:
      FrequentPairInserterNoprune( cand_vector_t& candidates, 
				   D& decoder, DUMMY& dummy ) : 
	 candidates(candidates), decoder(decoder){}


      /// Insert the frequent itempairs and their counters into the data structure;
      void insertFrequentPairs(
	 const std::vector< std::pair< counter_t, 
	 std::pair<item_t, item_t> > >& freq_pairs_with_counters )
      {
	 itemvector itemset;
	 for( std::vector< std::pair< counter_t, std::pair<item_t, item_t> > >::const_iterator 
		 it = freq_pairs_with_counters.begin(); it != freq_pairs_with_counters.end(); ++it)
	 {
	    itemset.push_back((*it).second.first);
	    itemset.push_back((*it).second.second);
	    candidates.push_back(itemvecCounterPair(itemset, (*it).first ) );
	    itemset.clear();
	 }
	 
	 for(cand_vector_t::iterator it = candidates.begin(); 
	     it != candidates.end(); ++it)
	    decoder.writeItemsetAndCounter(
	       (*it).first.begin(), (*it).first.end(), (*it).second);
      }
};

}
}

#endif
