/***************************************************************************
                          InfrequentRemover.cpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef InfrequentRemover_HPP
#define InfrequentRemover_HPP

/**
  *@author Ferenc Bodon
  */


#include "apriori/bodon-vector/vector_typedef.hpp"
#include "common/log.h"
//#include <cstdio>
//#include <iterator>	//for test




namespace Bodon
{
namespace vector_based
{
   template <class D, class DUMMY>
   class InfrequentRemover 
   {
      protected:
	 cand_vector_t& candidates; 
	 D& decoder;
      public:
	 InfrequentRemover<D, DUMMY> 
	 (cand_vector_t& candidates, D& decoder, DUMMY& dummy) :
	    candidates(candidates), decoder(decoder){}


	 void deleteInfrequent( const counter_t min_supp, 
				const unsigned int candidate_size );
	 void afterWorkDel(){}
      protected:


   };
/**
   \param min_supp The threshold of absolute support.
   \param candidate_size The size of the candidate itemset.
*/
   template <class D, class DUMMY> inline
   void InfrequentRemover<D, DUMMY>::
   deleteInfrequent( const counter_t min_supp, 
		     const unsigned int candidate_size )
   {
      cand_vector_t::iterator it = candidates.begin(); 
      while(it != candidates.end())
	 if((*it).second < min_supp)
	    it = candidates.erase(it);
	 else
	 {
	    decoder.writeItemsetAndCounter(
	       (*it).first.begin(), (*it).first.end(), (*it).second);
	    ++it;
	 }
   }
}
}
#endif
