/***************************************************************************
                          SupportCounter.hpp  -  description
                             -------------------
    begin                : cs dec 26 2004
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef SupportCounter_HPP
#define SupportCounter_HPP

/**
  *@author Ferenc Bodon
  */


#include "apriori/bodon-vector/vector_typedef.hpp"
//#include <cstdio>
//#include <iterator>	//for test




namespace Bodon
{
namespace vector_based
{
   template<class DATA_STRUCTURE>
   class SupportCounter
   {
      public:
	 SupportCounter<DATA_STRUCTURE>() {}

      public:
	 /// Increases the counter of those candidates that are contained 
	 /// by the given basket.
	 void updateCounters( 
	    DATA_STRUCTURE& candidates, const std::vector<item_t>& transaction, 
	    const unsigned int candidate_size, const counter_t counter_incr );
	 void updateCounters( 
	    DATA_STRUCTURE& candidates, std::vector<item_t>::const_iterator transaction_beg, 
	    std::vector<item_t>::const_iterator transaction_end,
	    const unsigned int candidate_size, const counter_t counter_incr );
   };

   template<class DATA_STRUCTURE> inline
   void SupportCounter<DATA_STRUCTURE>::updateCounters( 
      DATA_STRUCTURE& candidates, const std::vector<item_t>& transaction, 
      const unsigned int candidate_size, const counter_t counter_incr )
   {
//      copy(transaction.begin(), transaction.end(), ostream_iterator<item_t>(std::cout, " "));
//      std::cout<<std::endl;
      updateCounters( 
	 candidates, transaction.begin(), 
	 transaction.end(), candidate_size, counter_incr);

   }
   template<class DATA_STRUCTURE> inline
   void SupportCounter<DATA_STRUCTURE>::updateCounters( 
      DATA_STRUCTURE& candidates, std::vector<item_t>::const_iterator transaction_beg, 
      std::vector<item_t>::const_iterator transaction_end,
      const unsigned int candidate_size, const counter_t counter_incr )
   {
      for(typename DATA_STRUCTURE::iterator it = candidates.begin(); 
	  it != candidates.end(); ++it)
      {
	 if((*it).first.isContained(transaction_beg, transaction_end ))
	    (*it).second += counter_incr;
      }
   }

}
}
#endif
