/***************************************************************************
                          InnerNodeSpecific.cpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef InnerNodeSpecific_HPP
#define InnerNodeSpecific_HPP

/**
  *@author Ferenc Bodon
  */


#include "common.hpp"
//#include <iterator>	//for test


namespace Bodon
{
   /** This struct represent an edge of a InnerNodeSpecific.
       
   An edge has a label, and an edge points to a subtrie.
   */

   template <class EDGELIST>
   class InnerNodeSpecific
   {
      public:
	 typedef typename EDGELIST::iterator iterator;
	 typedef typename EDGELIST::const_iterator const_iterator;

	 EDGELIST edgelist;

	 InnerNodeSpecific(){}

	 bool isThereAnyCandidate() const
	 {
	    return !edgelist.empty();
	 }


	 size_t edgeNumber()
	 {
	    return edgelist.edgeNumber();
	 }
   };
}

#endif
