/***************************************************************************
                          ManipulatorBase.hpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef ManipulatorBase_HPP
#define ManipulatorBase_HPP

/**
  *@author Ferenc Bodon
  */


#include "common.hpp"
#include "common/Edge.hpp"
#include <vector>
//#include <cstdio>
//#include <iterator>	//for test


namespace Bodon
{
   template <class DF_D, class TRIE>
   class ManipulatorBase
   {
      protected:
	 /// Trie to store the candidates.
	 TRIE& main_trie;
	 /// The depth-first decoder
	 DF_D& df_decoder;

      public:
	 ManipulatorBase( TRIE& main_trie, DF_D& df_decoder ) : 
	    main_trie(main_trie), df_decoder(df_decoder){}

	 bool isThereAnyCandidate() const
	 {
	    return main_trie.isThereAnyCandidate();
	 }

   };
}


#endif
