
/**
 *@author Balazs RACZ
 */

#include "common.hpp"
#include "io/FDRepr.hpp"
#include "io/input/transaction_reader/TransactionReader.hpp"
#include "io/input/transaction_reader/brBufferedTransactionReader.hpp"
#include "io/input/transaction_reader/SortedTransactionReader.hpp"
#include "io/output/OutputBase.hpp"
#include "util/Formatter.hpp"
#include <vector>

int main(int argc,  char *argv[]) 
{
   if ( argc < 3 ) 
   {
      log_err(0,"Error! There are 2 mandatory arguments: input_canon infile outfile");
      return 1;
   }

   typedef bracz::brBufferedTransactionReader< TransactionReader<FDRepr> > T_R;
   typedef SortedTransactionReader<T_R, true> S_T_R;
   S_T_R::params_t par_i;
   par_i.file_name = argv[1];
   par_i.mode=FileReprBase::READ;
   par_i.file_buffer_size = 16 * 1024;
   S_T_R sorted_tr_reader(&par_i);

   OutputBase<FDRepr>::params_t par_o;
   par_o.file_name=argv[2];
   par_o.mode=FileReprBase::WRITE;
   OutputBase<FDRepr> of(&par_o);
   char buffer[60000];
   std::streamsize endpos,pos;
   endpos=sizeof(buffer)-1;
   std::vector<item_t> trans;
   sorted_tr_reader.rewind();
   while (sorted_tr_reader.nextTransactionBIS(trans))
   {
      pos=endpos;
      Formatter::ItemsetToStringBack(trans.begin(),trans.end(),buffer,pos);
      buffer[endpos-1]='\n';
      of.writeToFile(buffer+pos,endpos-pos);
   }
   of.flush();
   return 0;
}
