/***************************************************************************
                          Edge.hpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef Edge_HPP
#define Edge_HPP

/**
  *@author Ferenc Bodon
  */


#include "common.hpp"


/** This struct represent an edge.
    
An edge has a label, and an edge points to a subtrie.
*/

class Edge : public std::pair<item_t, void*>
{
   public:
      Edge():std::pair<item_t, void*>(){}
      Edge(item_t label, void* subtrie) : 
	 std::pair<item_t, void*>(label, subtrie){}
      
      bool operator<(const item_t other_label) const
      {
	 return first < other_label;
      }
      bool operator>(const item_t other_label) const
      {
	 return first > other_label;
      }

      bool operator==(const item_t other_label) const
      {
	 return first == other_label;
      }

};

#endif
