/**
 * Some utility functions for the commandline tools.
 */

#include "commandline.hpp"
#include "log.h"

#include <iostream>
#include <string>

std::string file_format;


void init()
{
   file_format = "File format:";
   file_format += "\n\nThe transactionfile is a plan text file. Each row ";
   file_format += "represents a transaction. \n";
   file_format += "A transaction is a set of items seperated by a nonnumeric ";
   file_format += "character.\nIt can be for example a white space, comma, ";
   file_format += "colon, etc.\n";
   file_format += "Items are nonnegative integers.\n";
}
/// This procedure displays the usage of the program.
void usage()
{
   std::cerr << "\nUsage: fim algorithm transactionfile outcomefile ";
   std::cerr << "min_supp [options]\n";
   std::cerr << "\n algorithm\t    the name of the algorithm, i.e: input_test, ";
   std::cerr << "simple_output_test apriori, eclat or fp-growth";
   std::cerr << "\n transactionfile\t    file, that contains the tranasctions of items";
   std::cerr << "\n outcomefile\t    file to write the outcome";
   std::cerr << "\n min_supp\t    absolute support threshold";

   std::cerr << "\n\nFile formats:";
   std::cerr << "\n\nThe transactionfile is a plan text file. Each row represents";
   std::cerr << " a transaction. "<<std::endl;
   std::cerr << "A transaction is a set of items seperated by a nonnumeric character.";
   std::cerr << "\nIt can be for example a white space, comma, colon, etc. \n";
   std::cerr << "Items are nonnegative integers.\n";
   std::cerr << "\n\nHave a succesful mining ;-)";
}

int process_arguments( int argc, char *argv[], counter_t& min_supp, 
		       bool &isrel, double &relminsupp )
{
   if ( argc < 5 )
   {
     usage();
     std::cerr<<"\nError! There are 4 mandatory arguments!\n"<<std::flush;
     return 1;
   }
   std::string mins=argv[4];
   if (mins[mins.size()-1]=='%') {
     mins.erase(mins.size()-1);
     isrel=true;
     relminsupp=atof(mins.c_str());
     relminsupp/=100;
     log_info(0,"Using relative minimum support of %lg",relminsupp);
     return 0;
   }
   min_supp = atoi(argv[4]);
   if ( min_supp <= 0  )
   {
      usage();
      std::cerr<<"\nError!\n min_supp should be positive."<<std::endl;
      return 1;
   }
        
   return 0;
}


int process_arguments( int argc, char *argv[], counter_t& min_supp )
{
   if ( argc < 5 )
   {
     usage();
     std::cerr<<"\nError! There are 4 mandatory arguments!\n"<<std::flush;
     return 1;
   }
   min_supp = atoi(argv[4]);
   if ( min_supp <= 0  )
   {
      usage();
      std::cerr<<"\nError!\n min_supp should be positive."<<std::endl;
      return 1;
   }
        
   return 0;
}


