/*
 * debug.hpp
 *
 * Time-stamp: <05/04/25 11:33:38 lars>
 *
 * history: 2004/04/01  1.0  LST created.
 */

#ifndef __DEBUG__
#define __DEBUG__ 

/**
 * Utility definitions for debugging.
 *
 * @author Lars Schmidt-Thieme
 * @version 1.0
 */

// 0. set default debug level:
#ifndef DEBUG_LEVEL
#define DEBUG_LEVEL 50
#endif

#if DEBUG_LEVEL <= 50
#define NDEBUG
#endif

// 1a. always include iostream for debugging:
#include <iostream>
using namespace std;
// 1b. use assertions depending on NDEBUG
#include <cassert>

/*#else
// 1'. ABSOLUTELY NO DEBUGGING:
// 1'a. do not use assertions:
#define assert(x) 
#endif
*/


#endif
