// features.hpp
//   algorithmic and implementation features.



// some global implementation features:
#ifndef USE_LOCAL_ARRAYS
#define USE_LOCAL_ARRAYS false
#endif

#if USE_LOCAL_ARRAYS
// requirements for local arrays:
//  - there is no other variables by the name {x}values
//  - x has a method int* values() that returns the values.
//  - x has operator[] to access its elements.
//  - x has a method setElement(int pos, int value) to set an element.
#define LOCAL_ARRAY_NAME(x) x ## values
#define LOCAL_INT_ARRAY(x) int* const LOCAL_ARRAY_NAME(x) = x .values();
#define CONST_LOCAL_INT_ARRAY(x) int const * const LOCAL_ARRAY_NAME(x) = x .values();
#define GET(x,index) LOCAL_ARRAY_NAME(x) [index]
#define SET(x,index,value) LOCAL_ARRAY_NAME(x) [index] = value;

#else // ! USE_LOCAL_ARRAYS
#define LOCAL_ARRAY_NAME(x) x
#define LOCAL_INT_ARRAY(x)
#define CONST_LOCAL_INT_ARRAY(x)
#define GET(x,index) x [index]
#define SET(x,index,value) x .setElement(index, value)
#endif

 
