/*!
  \file   PrefixArrayList.cpp
  \brief  

  \author Ferenc Bodon
  \date   2005-12-15
*/

#ifndef PREFIXARRAYLIST_HPP_050403
#define PREFIXARRAYLIST_HPP_050403


//#include "common/allocators.cpp"
#include <algorithm>

typedef std::vector< std::vector<itemvecCounterPair> > diag_array_row_t;
typedef std::vector<diag_array_row_t> diag_array_t;

template<unsigned int THRESHOLD = 100>
class PrefixArrayList : public diag_array_t{
   protected:

      bool less(const std::pair<itemvector, counter_t>& f, 
		const itemvector& s) const
      {
	 return f.first < s;
      }
   public:

      PrefixArrayList(const size_t largest_item) 
      {
	 diag_array_t::reserve(largest_item );
	 diag_array_t::resize(largest_item);
	 for( item_t index = 0; index < largest_item; ++index) 
	 {
	    diag_array_t::operator[](index).reserve(largest_item - index);
	    diag_array_t::operator[](index).resize(largest_item - index);
	 }
      }
/*      void insert( const itemvector& itemset, 
	const counter_t multiplicity );*/
};

/*template<unsigned int THRESHOLD = 100> void
PrefixArrayList<THRESHOLD>::insert( 
   const itemvector& itemset, const counter_t multiplicity )
{
      assert(itemset.size()>1);
      itemvector itemset_wp(itemset.begin()+2, itemset.end());
      set_list_t::iterator it;
      register size_t i1 = itemset[0], i2 = itemset[1]-itemset[0]-1;
      if(prefixarraylist[i1][i2].size() < THRESHOLD)
      {
	 it = prefixarraylist[i1][i2].begin();
	 while (it != prefixarraylist[i1][i2].end())
	    if( (*it).first < itemset_wp)
	       ++it;
	    else break;
      }
      else
      it = std::lower_bound( 
	 prefixarraylist[i1][i2].begin(),
	 prefixarraylist[i1][i2].end(), itemset_wp, less );
      
      if( it != prefixarraylist[i1][i2].end() && 
	  (*it).first == itemset_wp )
	 (*it).second += multiplicity;
      else
      prefixarraylist[i1][i2].insert(
	 it, std::pair<itemvector, counter_t>(itemset_wp, multiplicity));
}*/


#endif //PREFIXARRAYLIST_HPP_050403
