/***************************************************************************
                          DoubleRepr.hpp  -  description
                             -------------------
    begin                : cs dec 26 2002
    copyright            : (C) 2002 by Ferenc Bodon
    email                : bodon@cs.bme.hu
 ***************************************************************************/

#ifndef DoubleRepr_HPP
#define DoubleRepr_HPP

/**
  *@author Ferenc Bodon
  */


#include "common.hpp"
#include "datastructures/trie/edgelist/OrderedEdgelist.hpp"
#include "datastructures/trie/edgelist/OffsetIndexVector.hpp"
#include <vector>
//#include <iterator>	//for test


namespace Bodon
{
   template <class VECTOR_OL, class VECTOR_OI>
   class DoubleRepr : public OrderedEdgelist<VECTOR_OL>
   {
      private:
	 OffsetIndexVector<VECTOR_OI> offsetindexvector;

      public:
	 DoubleRepr() : OrderedEdgelist<VECTOR_OL>(){}
	 void clear()
	 {
	    OrderedEdgelist<VECTOR_OL>::clear();
	    offsetindexvector.clear();
	 }
	 typename VECTOR_OL::iterator erase(typename VECTOR_OL::iterator pos)
	 {
	    offsetindexvector.quickErase( (*pos).first );
	    return OrderedEdgelist<VECTOR_OL>::erase(pos);
	 }

	 bool lookup(item_t label, void*& subtrie)
	 {
	    /*
	    if( edgelist.back().first < label)
	       return false;
	    else
	    {
	       if(edgelist.front().first > label)
		  subtrie= NULL;
	       else
		  subtrie = offsetindexvector.getEdge(label);
	       return true;
	    }
	    */
	    return offsetindexvector.lookup(label, subtrie);
	 }
	 void insert(const std::vector<Edge>& new_edges)
	 {
	    OrderedEdgelist<VECTOR_OL>::insert(new_edges);
	    offsetindexvector.insert(new_edges);
	 }
   };
}

#endif
