#ifndef DecoderBase_HPP
#define DecoderBase_HPP

/**
  *@author Ferenc Bodon
  */
  
#include "common.hpp"
#include <vector>
#include <iostream>

/** This is a base class for a decoder, a class that
    is responsible to decode the items in an itemset and write it out.

    A decoder is an output manager extended by \c setCodeInverse function
 */
template <class O>
class DecoderBase : public O
{
   public:
      typedef typename O::params_t params_t;

      DecoderBase(const params_t* par):O(par){}
      /** This sets the invers of codes.
       
      \param code_inverse the inverse of the codes.
      Assume that the new code of item \e i is denoted by \e code[i].
      Then \a code_inverse[code[i]-1]=i if \e i is a frequent item.
      */
      void setCodeInverse(const std::vector<item_t>& code_inverse)
      {	 
	 std::cerr<<"Error: using function setCodeInverse"<<std::endl;
      }	 
};


#endif
