#ifndef SimpleDecoderBase_HPP
#define SimpleDecoderBase_HPP

/**
  *@author Ferenc Bodon
  */
  
#include "io/codec/decoder/DecoderBase.hpp"
#include "io/output/normal/BufferedNormalOutput.hpp" 
#include <vector>

/** This is a very simple decoder.

It just decodes the items of the itemset and sends
the result to an output manager.

O must be an output manager that implements \c writeItemsetAndCounter.
 */

template <class O = BufferedNormalOutput<> >
class SimpleDecoderBase : public DecoderBase<O>
{
   public:
      SimpleDecoderBase(const typename DecoderBase<O>::params_t* par)
	 : DecoderBase<O>(par){}
      void setCodeInverse(const std::vector<item_t>& code_inverse)
      {	 
	 this->code_inverse.insert( this->code_inverse.end(),
				    code_inverse.begin(), code_inverse.end());
      }	 
      
   protected:
      /** The inverse of code vector.

      \a code_inverse[i] stores the original code of the item,
      whose new code is \e i.
       */

      std::vector<item_t> code_inverse;
};


#endif
