#ifndef DFDecoderWrapper_HPP
#define DFDecoderWrapper_HPP

/*!
  \file   DFDecoderWrapper.hpp
  \brief  A DF style decoder that calls an ordinary DF style output manager

  \author RACZ Balazs
  \date   2005-04-08
*/

#include "io/codec/decoder/SimpleDecoderBase.hpp"  

namespace bracz
{
  /**
     \brief  A DF style decoder that calls an ordinary DF style output manager


     FR must be a DF Output Manager
  */
  template <class FR>
  class DFDecoderWrapper : public SimpleDecoderBase<FR>
  {
  public:

    typedef typename SimpleDecoderBase<FR>::params_t params_t;
    DFDecoderWrapper(const params_t* par)
      : SimpleDecoderBase<FR>(par){
    }

    static bool DINLINE isDFO()
    {
      return true;
    }  

    void pushItem(item_t item)
    {
      FR::pushItem(code_inverse[item]);
    }

    void pushItemWithWrite(item_t item, counter_t support)
    {
      FR::pushItemWithWrite(code_inverse[item],support);
    }
	 
    void pushItemWithPrevSupport(item_t item)
    {
      FR::pushItemWithPrevSupport(code_inverse[item]);
    }

  };
}
#endif
