#ifndef CacheNormalDecoder_HPP
#define CacheNormalDecoder_HPP

/**
 *@author Ferenc Bodon
 */

#include <iterator>
#include "io/codec/decoder/CacheDecoderBase.hpp"  
#include "io/FDRepr.hpp"  

template <class FR = FDRepr>
class CacheNormalDecoder : public CacheDecoderBase<FR>
{
   protected: 
      typedef CacheDecoderBase<FR> PARENT;
   public:

      typedef typename CacheDecoderBase<FR>::params_t params_t;

      CacheNormalDecoder(const params_t* par)
	 : CacheDecoderBase<FR>(par){}

      static bool DINLINE isDFO()
      {
	 return false;
      }  


      template <typename InputIterator> void writeItemsetAndCounter(
	 InputIterator first, InputIterator last, 
	 counter_t support )
      {
	 std::streamsize pos = PARENT::buffer_size;
	 Formatter::SupportToStringBack(support, PARENT::buffer, pos);

	 unsigned int length;
	 while( last != first )
	 {
	    --last;
	    PARENT::buffer[--pos] = ' ';
	    length = PARENT::code_inverse[*last].second;
	    pos -= length;
	    memcpy( &PARENT::buffer[pos], PARENT::code_inverse[*last].first, 
		    length);
	 }
	 writeToFile( &PARENT::buffer[pos], PARENT::buffer_size - pos );   
      };
};

#endif
