#ifndef SimpleNormalDecoder_HPP
#define SimpleNormalDecoder_HPP

/**
 *@author Ferenc Bodon
 */

#include <iterator>
#include "io/codec/decoder/SimpleDecoderBase.hpp"  
#include "io/output/normal/BufferedNormalOutput.hpp"  

template <class O = BufferedNormalOutput<> >
class SimpleNormalDecoder : public SimpleDecoderBase<O>
{
   protected:
      typedef SimpleDecoderBase<O> PARENT;

   public:
      typedef typename SimpleDecoderBase<O>::params_t params_t;
      SimpleNormalDecoder(const params_t* par)
	 : PARENT(par){}

      static bool DINLINE isDFO()
      {
	 return false;
      }  


      template <typename InputIterator> void writeItemsetAndCounter(
	 InputIterator first, InputIterator last, 
	 counter_t support )
      {
	 static std::vector<item_t> decoded_set;
	 decoded_set.clear();
	 while(first != last)
	 {
	    decoded_set.push_back(PARENT::code_inverse[*first]);
	    ++first;
	 }
	 O::writeItemsetAndCounter( 
	    decoded_set.begin(), decoded_set.end(), support );	 
      }
};

#endif
