#ifndef PrefixArrayListDBCache_HPP
#define PrefixArrayListDBCache_HPP

/**
  *@author Ferenc Bodon
  */
  
#include "common.hpp"
#include "datastructures/PrefixArrayList.hpp"
#include <vector>
//#include <fstream>

template <class T_R, unsigned THRESHOLD = 100>
class PrefixArrayListDBCache : public T_R, public PrefixArrayList<THRESHOLD>
{
   public:
      typedef typename T_R::params_t params_t;
      PrefixArrayListDBCache( const params_t* par ) :
	 T_R(par), PrefixArrayList<THRESHOLD>(par->largest_item)
      {
	 std::vector<item_t> transaction;
	 register counter_t multiplicity;
	 T_R::rewind();
	 while( (multiplicity = T_R::nextTransactionBIS(
		    transaction)) != 0 )
	    if(transaction.size() > 1) 
	       PrefixArrayList<THRESHOLD>::insert( 
		  transaction,  multiplicity);
      }
      template <class BIS> counter_t nextTransactionBIS( 
	 BIS& transaction ){return 0;}

      void rewind()
      {
      }
      
};

#endif
