#ifndef TrieDBCache_HPP
#define TrieDBCache_HPP

/**
  *@author Ferenc Bodon
  */
  
#include "common.hpp"
#include "datastructures/trie/TrieBase.hpp"
#include <vector>
//#include <fstream>

   template <class T_R, class EDGELIST>
   class TrieDBCache : public T_R, public TrieBase<EDGELIST, counter_t>
   {
      public:
	 typedef typename T_R::params_t params_t;

	 TrieDBCache( const params_t* par );
	 
	 template <class BIS> counter_t nextTransactionBIS( 
	    BIS& transaction );

	 void rewind()
	 {
	    it = TRIE::begin();
	 }


      protected:
	 typedef TrieBase<EDGELIST, counter_t> TRIE;
	 typename TRIE::iterator it;
   };

   template <class T_R, class EDGELIST> inline TrieDBCache<T_R, EDGELIST>::
   TrieDBCache(const params_t* par) : T_R(par), TrieBase<EDGELIST, counter_t>()
   {
      std::vector<item_t> transaction;
      register counter_t multiplicity;
      T_R::rewind();
      while( (multiplicity = T_R::nextTransactionBIS(
		 transaction)) != 0 )
	 if(transaction.size() > 1) 
	    TRIE::addItemset( transaction, transaction.begin() ).getData() 
	       += multiplicity;
   }

   template <class T_R, class EDGELIST> template <class BIS> inline 
   counter_t TrieDBCache<T_R, EDGELIST>::nextTransactionBIS( BIS& transaction )
   {
      std::pair<BIS, counter_t> temp_pair;
      while(it != TRIE::end() )
      {
	 temp_pair = *it;
	 ++it;
	 if(temp_pair.second != 0)
	 {
	    transaction = temp_pair.first;
	    return temp_pair.second;
	 }
      }
      return 0;

   }
#endif
