#ifndef BufferedTransactionReader_HPP
#define BufferedTransactionReader_HPP

#include "io/input/transaction_reader/TransactionReader.hpp"  

// Base class for buffered TransactionReaders.
template <class T_R = TransactionReader<> >
class BufferedTransactionReader : public T_R
{
   public:
      class params_t : public T_R::params_t
      {
	 public:
	    /// the size of the buffer
	    std::streamsize buffer_size;
	    params_t()
	    {
	       buffer_size = 32 * 1024;
	    }
      };

      BufferedTransactionReader( const params_t* par )
	 : T_R( par), buffer_size(par->buffer_size)
      {
	 buffer = new char[buffer_size];
      }

      /// frees the buffer
      ~BufferedTransactionReader()
      {
	 delete[] buffer;
      }

   protected:
      /// The size of the buffer
      std::streamsize buffer_size;
      /// The buffer
      char* buffer;
};


#endif
