#ifndef OrderReverser_HPP
#define OrderReverser_HPP

/**
  *@author Ferenc Bodon
  */

#include "common.hpp"
#include "io/input/transaction_reader/TransactionReader.hpp"  
#include <algorithm>

/** This wrapper class reverses the order of the transactions that are obtained from a transaction reader.
*/
template < class T_R = TransactionReader<> > 
class OrderReverser : public T_R
{
   public:
      typedef typename T_R::params_t params_t;
      OrderReverser( const params_t* par ) : T_R(par){}

      template <class BIS> counter_t nextTransactionBIS( BIS& transaction )
      {
	 counter_t return_value = T_R::nextTransactionBIS(transaction);
	 std::reverse(transaction.begin(), transaction.end());
	 return return_value;
      }
};

#endif
