/*!
  \file   brBufferedTransactionReader.hpp
  \brief  Another buffered transaction reader, taken from bracz's FIMI04 code

  \author RACZ Balazs
  \date   2005-04-05
*/

#ifndef brBufferedTransactionReader_050405
#define brBufferedTransactionReader_050405


#include "io/input/transaction_reader/BufferedTransactionReader.hpp"  
#include <stdio.h>
#include <fstream> //for exceptions
#include <string.h>
#include <cerrno>
#include "common/log.h"
#include <string>


/** 
    Another buffered transaction reader, taken from bracz's FIMI04 code 

*/
template <class T_R = TransactionReader<> >
class brBufferedTransactionReader : public BufferedTransactionReader<T_R>
{
   private:
      char *bufp, *bufend;
      bool ateof;

   public:
      typedef typename BufferedTransactionReader<T_R>::params_t params_t;

      brBufferedTransactionReader( const params_t* par) : 
	 BufferedTransactionReader<T_R>(par)
      {
	 //setbuffer(fin,buffer,buffer_size);
      }

      inline void DINLINE nextChar(char &c) 
      {
	 c=*bufp;
	 if ((++bufp)==bufend) {
	    bufp=this->buffer;
	    std::streamsize r=readFromFile(this->buffer,this->buffer_size);
	    if (r)
	       bufend=bufp + r;
	    else {
	       ateof=true;
	       *bufp='\n';
	    }
	 }
      } 

      /** Reads in one transaction from the file and writes it to a class 
	  whose type is given by the template.


      */
      template <class BIS> counter_t nextTransactionBIS( BIS& Items ){
	 Items.clear();
	 if (ateof) {
	    return 0;
	 }
	 char c;
	 do {
	    item_t item=0;
	    nextChar(c);
	    //        int pos=0;
	    if ((c >= '0') && (c <= '9')) {
	       item = (c-'0');
	       nextChar(c);
	       while((c >= '0') && (c <= '9')) {
		  item *=10;
		  item += int(c)-int('0');
		  // c = getc(fin);
		  nextChar(c);
	       }
	       Items.push_back(item);
	    }
	    /*          if (item>largest_item)
			largest_item=item;*/
	 }while((c != '\n') && (!ateof));
	 if (Items.size())
	    return 1;
	 return 0;
      }

      /** Reads in one transaction from the file and writes it to a class 
	  whose type is given by the template.
      */
      template <class UAC> counter_t nextTransactionUAC( UAC& transaction ){
	 transaction.clear();
         return 0;
      }

      /// Go to the beginning of the transaction file.
      void rewind()
      {
	 T_R::rewind();
	 std::streamsize r = readFromFile(this->buffer,this->buffer_size);;
	 bufp = this->buffer; 
	 bufend = this->buffer + r;
	 ateof = false;
      }
}; //class bufferedtransactionreader

#endif //brBufferedTransactionReader_050405
