/*!
  \file   BufferedNormalOutput.hpp
  \brief  A simple Output manager that use buffering.

  \author Ferenc BODON
  \date   2005-05-02
*/
#ifndef BufferedNormalOutput_HPP
#define BufferedNormalOutput_HPP


#include "util/Formatter.hpp"
#include "io/output/BufferedOutput.hpp"
#include "io/FDRepr.hpp"  

/// A simple BufferedOutput manager
template <class FR = FDRepr>
class BufferedNormalOutput : public BufferedOutput<FR>
{
   public:
      typedef typename BufferedOutput<FR>::params_t params_t;
      
      BufferedNormalOutput(const params_t* par):
	 BufferedOutput<FR>(par){}


      static bool DINLINE isDFO()
      {
	 return false;
      }  


      template <typename InputIterator> void writeItemsetAndCounter(
 	 InputIterator first, InputIterator last, 
	 counter_t support )
      {
	 register std::streamsize pos = this->buffer_size;
	 Formatter::SupportToStringBack( support, this->buffer, pos );
	 Formatter::ItemsetToStringBack( first, last, this->buffer, pos);
	 writeToFile( &(this->buffer[pos]), this->buffer_size - pos );
      }
};

#endif
