#ifndef SimpleOutput_HPP
#define SimpleOutput_HPP

/**
 *@author Ferenc Bodon
 */

#include <iterator>
#include "io/StreamRepr.hpp"  
#include "io/output/OutputBase.hpp"  

/** This is a very simple class that implements 
    OutputBase::writeItemsetAndCounter by the call of 
    an STL' copy procedure. The main purpose of this class is to 
    provide a basic class for the tests. If the size of the output
    is large, and the performance is important, you should use a
    BufferedOutput like NormalBufferedOutput. For more information 
    about the performance of the different output classes test_results.html.
    \see test_results.html 
*/
class SimpleOutput : public OutputBase<StreamRepr>
{
   public:

      typedef OutputBase<StreamRepr>::params_t params_t;

      SimpleOutput(const params_t* par) : 
	 OutputBase<StreamRepr>(par) {}

      static bool DINLINE isDFO()
      {
	 return false;
      }  


      template <typename InputIterator> void writeItemsetAndCounter(
	 InputIterator first, InputIterator last, 
	 counter_t support )
      {
	 std::copy( first, last, 
		    std::ostream_iterator<item_t>(output_stream, " "));
	 output_stream<<'('<<support<<")\n";
      }
};

#endif
