// LightVector_STL_set_difference_Test.cpp

#include "datastructures/vector/LightVector.hpp"
#include <iostream>
using namespace std;

/**
 * Simple test for STL set_difference algorithm on a LightVector.
 *
 * @author Lars Schmidt-Thieme
 */
int main(int argc, char** argv) {

  int values[] = { 1, 3, 5, 7, 9, 11, 13 };
  int len = 7;
  int values2[] = { 1, 2, 4, 6, 7, 9 };
  int len2 = 6;

  const LightVector<int> x(values, len), y(values2, len2);
  LightVector<int>* res = LightVector<int>::create(10, 0);

  cout << "x = " << x << endl;
  cout << "y = " << y << endl;
#if DEBUG_LEVEL > 0
  cout << "res.capacity = " << res->capacity() << endl;
#endif

  res.resize(10);
  LightVector<int>::iterator resIter = res->begin(); // Unbounded();
  resIter = set_difference(x.begin(), x.end(), y.begin(), y.end(), resIter);
  res->resize(resIter - res->begin()); // Unbounded());
  
  cout << "set_difference(x,y) = " << *res << endl;

}
