// LightVector_set_intersection_Test.cpp

#include "datastructures/vector/LightVector.hpp"
#include "datastructures/vector/LightVector_set_intersection.hpp"
#include <iostream>
using namespace std;

/**
 * Simple test for set_intersection algorithm on a LightVector.
 *
 * @author Lars Schmidt-Thieme
 */
int main(int argc, char** argv) {


  int values[] = { 1, 3, 5, 7, 9 };
  int len = 5;
  int values2[] = { 1, 2, 4, 6, 7, 9 };
  int len2 = 6;

  const LightVector<int> x(values, len), y(values2, len2);
  LightVector<int>* res = LightVector<int>::create(10, 0);

  cout << "x = " << x << endl;
  cout << "y = " << y << endl;
#if DEBUG_LEVEL > 0
  cout << "res.capacity = " << res->capacity() << endl;
#endif

  set_intersection<false>(*res, x, y);
  cout << "set_intersection<false>(x,y) = " << *res << endl;

  bool hasMinimalLength = set_intersection<true>(*res, x, y, 4);
  cout << "set_intersection<true>(x,y,4) = " << *res << ", hasMinimalLength = " << hasMinimalLength<< endl;

							 

}
