// LightVector_set_difference_Test.cpp

#include "datastructures/vector/set_difference.hpp"
#include <iostream>
#include <iterator>
#include <vector>
using namespace std;

/**
 * Simple test for set_difference algorithm on a STL vector.
 *
 * @author Lars Schmidt-Thieme
 */
int main(int argc, char** argv) {

  int values[] = { 1, 3, 5, 7, 9, 11, 13 };
  int values2[] = { 1, 2, 4, 6, 7, 9 };

  const vector<int> x(values, values+7), y(values2, values2+6);
  vector<int> res(10);
  res.resize(0);

  cout << "x = ";
  copy (x.begin(), x.end(), ostream_iterator<int>(cout, " "));
  cout << endl;
  cout << "y = ";
  copy (y.begin(), y.end(), ostream_iterator<int>(cout, " "));
  cout << endl;
#if DEBUG_LEVEL > 0
  cout << "res.capacity = " << res.capacity() << endl;
#endif

  set_difference(x, y, res);
  cout << "set_difference(x,y) = ";
  copy (res.begin(), res.end(), ostream_iterator<int>(cout, " "));
  cout << endl;

  bool isBelowUpperSizeBound = set_difference_upper_size_bound(x, y, res, 3);
  cout << "set_difference_upper_size_bound(x,y,3) = ";
  copy (res.begin(), res.end(), ostream_iterator<int>(cout, " "));
  cout << ", isBelowUpperSizeBound = " << isBelowUpperSizeBound << endl;

}
