
#include "eclat/SparseBitvector.hpp"
#include "eclat/SparseBitvector_intersection.hpp"

#include <iostream>
using namespace std;

int main(int argc, char** argv) {

  // intersection / case #1:

  int xval[] = { 1, 2, 4, 6 };
  int yval[] = { 1, 3, 5, 6 };
  int lenx = 4, leny = 4, lenres = 0;
  SparseBitvector x(xval, &lenx, 4), y(yval, &leny, 4), res(new int[10], &lenres, 10);

  cout << "before: "
       << "x = " << x 
       << ", y = " << y
       << ", res = " << res 
       << endl;

  bool complete = intersection<true,true>(res, x, y, 2);

  cout << "after : "
       << "x = " << x 
       << ", y = " << y
       << ", res = " << res 
       << ", complete = " << complete
       << ", lenx = " << lenx
       << ", leny = " << leny
       << ", lenres = " << lenres
       << endl;

  // intersection / case #2:

  int x2val[] = { 0, 2, 4, 7 };
  int y2val[] = { 1, 3, 5, 6 };
  int lenx2 = 4, leny2 = 4, lenres2 = 0;
  SparseBitvector x2(x2val, &lenx2, 4), y2(y2val, &leny2, 4), res2(new int[10], &lenres2, 10);

  cout << "before: "
       << "x2 = " << x2 
       << ", y2 = " << y2
       << ", res2 = " << res2 
       << endl;

  bool complete2 = intersection<true,true>(res2, x2, y2, 0);

  cout << "after : "
       << "x2 = " << x2 
       << ", y2 = " << y2
       << ", res2 = " << res2 
       << ", complete2 = " << complete2
       << ", lenx2 = " << lenx2
       << ", leny2 = " << leny2
       << ", lenres2 = " << lenres2
       << endl;

  
  // length reference sharing:

  y.set(xval, &lenx, 4);
  y.setLength(0); // as x and y share lenx by now, both should be empty.

  cout << "after2: "
       << "x = " << x 
       << ", y = " << y
       << ", res = " << res 
       << ", complete = " << complete
       << ", lenx = " << lenx
       << ", leny = " << leny
       << endl;


}
