
#include <vector>

#include "common.hpp"
#include "io/FILERepr.hpp"
#include "io/codec/decoder/df/DFDecoderWithEEManagement.hpp"

typedef std::vector<item_t> ItemVector;
typedef DFDecoderWithEEManagement< Bodon::CacheDFDecoder<FILERepr> > PatternOutput;

int main(int argc, char** argv) {
  ItemVector codeInverses;
  for (int i = 0; i < 10; i++)
    codeInverses.push_back(i);

  PatternOutput::params_t par_d;
  par_d.file_name = "test.pat";
  par_d.mode=FileReprBase::WRITE;
  PatternOutput out(&par_d);
  out.setCodeInverse(codeInverses);

  out.pushItem(1);
  out.write(10); 
  
  out.pushItem(2);
  out.pushEquisupportItem(4);
  out.write(7);

  out.pushItem(3);
  out.pushEquisupportItem(5);
  out.pushEquisupportItem(6);
  out.write(3);
  out.popItem();

  out.popItem();

  out.pushItemWithWrite(3, 6);

}
