#ifndef StreamParser_HPP
#define StreamParser_HPP

// This code was taken from here:
// http://www.parashift.com/c++-faq-lite/misc-technical-issues.html

#include <stdexcept>
#include <sstream>

class BadConversion : public std::runtime_error {
 public:
   BadConversion(const std::string& s)
     : std::runtime_error(s) { }
 };
 
 template<typename T>
 inline void convert(const std::string& s, T& x,
                     bool failIfLeftoverChars = true)
 {
   std::istringstream i(s);
   char c;
   if (!(i >> x) || (failIfLeftoverChars && i.get(c)))
     throw BadConversion(s);
 }

#endif
